//------------------------------------------------------------------------------
// <copyright file="TextAlign.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>                                                                
//------------------------------------------------------------------------------

/*
 */

namespace System.Web.UI.WebControls {
    
    using System;


    /// <devdoc>
    ///    <para>Specifies the text alignment within a control.</para>
    /// </devdoc>
    public enum TextAlign {


        /// <devdoc>
        ///    <para>The text is aligned to the left within the enclosing control.</para>
        /// </devdoc>
        Left = 1,


        /// <devdoc>
        ///    <para>The text is aligned to the right within the
        ///       enclosing control.</para>
        /// </devdoc>
        Right = 2,

    }
}
