//
// System.Web.Configuration.AssemblyCollection
//
// Authors:
//	Lluis Sanchez Gual (lluis@novell.com)
//	Chris Toshok (toshok@ximian.com)
//
// (C) 2004,2005 Novell, Inc (http://www.novell.com)
//

//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//


using System;
using System.Configuration;

namespace System.Web.Configuration
{
	[ConfigurationCollection (typeof (AssemblyInfo), CollectionType = ConfigurationElementCollectionType.AddRemoveClearMap)]
	public sealed class AssemblyCollection: ConfigurationElementCollection
	{
		static ConfigurationPropertyCollection properties;

		static AssemblyCollection ()
		{
			properties = new ConfigurationPropertyCollection();
		}

		public void Add (AssemblyInfo info)
		{
			BaseAdd (info, false);
		}
		
		public void Clear ()
		{
			BaseClear ();
		}
		
		protected override ConfigurationElement CreateNewElement ()
		{
			return new AssemblyInfo ();
		}
		
		protected override object GetElementKey (ConfigurationElement element)
		{
			return ((AssemblyInfo)element).Assembly;
		}
		
		public void Remove (string key)
		{
			BaseRemove (key);
		}
		
		public void RemoveAt (int index)
		{
			BaseRemoveAt (index);
		}

		public AssemblyInfo this [int index] {
			get { return (AssemblyInfo) BaseGet (index); }
			set {  if (BaseGet(index) != null)  BaseRemoveAt(index);  BaseAdd(index, value); }
		}

		public new AssemblyInfo this [string assemblyName] {
			get { return (AssemblyInfo) BaseGet (assemblyName); }
		}


		protected internal override ConfigurationPropertyCollection Properties {
			get { return properties; }
		}
	}
}

