// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Copyright (c) 2004 Novell, Inc.
//
// Authors:
//	Peter Bartok	pbartok@novell.com
//


// COMPLETE

namespace System.Windows.Forms {
	public enum AccessibleRole {
		None		= 0,
		TitleBar	= 1,
		MenuBar		= 2,
		ScrollBar	= 3,
		Grip		= 4,
		Sound		= 5,
		Cursor		= 6,
		Caret		= 7,
		Alert		= 8,
		Window		= 9,
		Client		= 10,
		MenuPopup	= 11,
		MenuItem	= 12,
		ToolTip		= 13,
		Application	= 14,
		Document	= 15,
		Pane		= 16,
		Chart		= 17,
		Dialog		= 18,
		Border		= 19,
		Grouping	= 20,
		Separator	= 21,
		ToolBar		= 22,
		StatusBar	= 23,
		Table		= 24,
		ColumnHeader	= 25,
		RowHeader	= 26,
		Column		= 27,
		Row		= 28,
		Cell		= 29,
		Link		= 30,
		HelpBalloon	= 31,
		Character	= 32,
		List		= 33,
		ListItem	= 34,
		Outline		= 35,
		OutlineItem	= 36,
		PageTab		= 37,
		PropertyPage	= 38,
		Indicator	= 39,
		Graphic		= 40,
		StaticText	= 41,
		Text		= 42,
		PushButton	= 43,
		CheckButton	= 44,
		RadioButton	= 45,
		ComboBox	= 46,
		DropList	= 47,
		ProgressBar	= 48,
		Dial		= 49,
		HotkeyField	= 50,
		Slider		= 51,
		SpinButton	= 52,
		Diagram		= 53,
		Animation	= 54,
		Equation	= 55,
		ButtonDropDown	= 56,
		ButtonMenu	= 57,
		ButtonDropDownGrid= 58,
		WhiteSpace	= 59,
		PageTabList	= 60,
		Clock		= 61,
		Default		= -1,
		SplitButton	= 62,
		IpAddress	= 63,
		OutlineButton	= 64
	}
}
